﻿; ****************************************************************************************************
; PROJECT       : TUTO_POO
; PACKAGE       : TUTO_POO.model
; DESIGNED WITH : PB 5.60
; NAME          : Circle
; VERSION       : 1
; DATE          :
; AUTHOR        : microdevWeb
; DESCRIPTION   :
; *****************************************************************************************************
DeclareModule fCircle
  Structure _struct Extends Form::_struct
    radius.l
  EndStructure
  Declare new(x,y,radius)
EndDeclareModule

Module fCircle
  ;-* GETTERS
  Procedure getRadius (*this._struct)
    With *this
      ProcedureReturn \radius
    EndWith
  EndProcedure
  
  ;}
  ;-* SETTERS
  Procedure setRadius (*this._struct,radius)
    With *this
      \radius = radius
      ProcedureReturn #True
    EndWith
  EndProcedure
  
  ;}
  ;-* PRIVATE METHODS
  
  ;}
  ;-* ABSTRACT METHODS
    Procedure draw (*this._struct)
      With *this
        ; we take red color for differentiating the rectangles
        If \selected
          VectorSourceColor($FF808000)
        Else
          VectorSourceColor($FF00FFFF)
        EndIf
        AddPathCircle(\x,\y,\radius)
        FillPath()
      EndWith
    EndProcedure
    
    Procedure mouseIsOnMe (*this._struct,x,y)
      With *this
        If (x>=(\x - \radius) And x<=(\x + \radius)) And (y>=(\y - \radius) And yx<=(\y + \radius))
          ProcedureReturn #True
        EndIf
        ProcedureReturn #False
      EndWith
    EndProcedure
    
    Procedure whoIam (*this._struct)
      With *this
        ProcedureReturn Form::#CIRCLE
      EndWith
    EndProcedure
    
  ;}
  ;-* PUBLIC METHODS
  
  ;}
  ;-* DESTRUCTOR is considered as a abstract method
  Procedure free(*this._struct)
    With *this
      ClearStructure(*this,_struct)
    EndWith
  EndProcedure
  ;}
  ;-* CONSTRUCTOR
  Procedure new(x,y,radius)
    Protected *this._struct = AllocateStructure(_struct)
    With *this
      If Not Form::super(x,y,*this,?METHODS) : ProcedureReturn #False : EndIf
      If Not setRadius(*this,radius) : ProcedureReturn #False : EndIf
      ProcedureReturn *this
    EndWith
  EndProcedure
  ;}
  DataSection
    ; It's very important: placed on the  first places the abstract methods
    METHODS:
    ; ABSTRACT METHODS
    Data.i @draw()
    Data.i @mouseIsOnMe()
    Data.i @whoIam()
    Data.i @free()
    ; CLASSICAL METHODS
    Data.i @getRadius()
    Data.i @setRadius()
  EndDataSection
EndModule
; IDE Options = PureBasic 5.61 (Windows - x64)
; CursorPosition = 82
; FirstLine = 49
; Folding = 4e9
; EnableXP