﻿; ****************************************************************************************************
; PROJECT       : TUTO_POO
; PACKAGE       : TUTO_POO.model
; DESIGNED WITH : PB 5.60
; NAME          : Form ABSTRACT CLASS
; VERSION       : 1
; DATE          :
; AUTHOR        : microdevWeb
; DESCRIPTION   :
; *****************************************************************************************************
DeclareModule Form
  Structure _struct
    *methods
    x.l
    y.l
    selected.b
  EndStructure
  Enumeration 
    #RECTANGLE
    #CIRCLE
  EndEnumeration
  Declare super(x,y,*this._struct,*methods)
EndDeclareModule

Module Form
  ;-* GETTERS
  Procedure getPosX (*this._struct)
    With *this
      ProcedureReturn \x
    EndWith
  EndProcedure
  
  Procedure getPosY (*this._struct)
    With *this
      ProcedureReturn \Y
    EndWith
  EndProcedure
  
  Procedure isSelected (*this._struct)
    With *this
      ProcedureReturn \selected
    EndWith
  EndProcedure
  ;}
  ;-* SETTERS
  Procedure setPosX (*this._struct,posX)
    With *this
      \x = posX
      ProcedureReturn #True
    EndWith
  EndProcedure
  
  Procedure setPosY (*this._struct,posY)
    With *this
      \y = posY
      ProcedureReturn #True
    EndWith
  EndProcedure
  
  Procedure setSelected (*this._struct,state.b)
      With *this
        \selected = state
        ProcedureReturn #True
      EndWith
    EndProcedure
  ;}
  ;-* PRIVATE METHODS
  
  ;}
  ;-* PUBLIC METHODS
  
  ;}
  ;-* CONSTRUCTOR DON'T INSTANCIATE
  Procedure super(x,y,*this._struct,*methods)
    With *this
      Protected nbOctets
      If Not setPosX(*this,x):ProcedureReturn #False : EndIf
      If Not setPosY(*this,y):ProcedureReturn #False : EndIf
      CompilerIf #PB_Compiler_Processor= #PB_Processor_x86
        nbOctets = 4
      CompilerElse
        nbOctets = 8
      CompilerEndIf
      ;we take the maximum of methods
      \methods = AllocateMemory(nbOctets * 12)
      ;we take the number of abstract methods
      MoveMemory(*methods,\methods,nbOctets * 4)
      ;we take the result of max methods - number of abstract methods
      MoveMemory(?METHODS,\methods + nbOctets * 4,nbOctets * 8)
      ProcedureReturn *this
    EndWith
  EndProcedure
  ;}
  DataSection
    METHODS:
    Data.i @getPosX()
    Data.i @getPosY()
    Data.i @isSelected()
    Data.i @setPosX()
    Data.i @setPosY()
    Data.i @setSelected()
  EndDataSection
EndModule
; IDE Options = PureBasic 5.61 (Windows - x64)
; CursorPosition = 87
; FirstLine = 64
; Folding = 4--
; EnableXP